# coding: utf-8

"""
    Ringer Business API - Account Management

    This API provides endpoints for managing customer accounts in the Ringer Business system. It allows for retrieving account details, updating account information, managing account status (activation/closure), and updating associated addresses.  Account operations typically require authentication and appropriate permissions (e.g., administrator role for certain updates). 

    The version of the OpenAPI document: 1.0.0
    Contact: support@ringer.tel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AccountUpdateRequest(BaseModel):
    """
    Specifies the fields that can be updated for an account.
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The official name of the account/company.")
    locale: Optional[StrictStr] = Field(default=None, description="Preferred language and regional settings (e.g., \"en-US\", \"en-GB\").")
    balance_preference_in_dollars: Optional[StrictStr] = Field(default=None, description="Desired minimum balance to maintain, in dollars.")
    recharge_preference_in_dollars: Optional[StrictStr] = Field(default=None, description="Amount to automatically recharge when balance falls below preference, in dollars.")
    maximum_recharge_preference_in_dollars: Optional[StrictStr] = Field(default=None, description="Maximum permissible auto-recharge amount in a single transaction, in dollars.")
    __properties: ClassVar[List[str]] = ["name", "locale", "balance_preference_in_dollars", "recharge_preference_in_dollars", "maximum_recharge_preference_in_dollars"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountUpdateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountUpdateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "locale": obj.get("locale"),
            "balance_preference_in_dollars": obj.get("balance_preference_in_dollars"),
            "recharge_preference_in_dollars": obj.get("recharge_preference_in_dollars"),
            "maximum_recharge_preference_in_dollars": obj.get("maximum_recharge_preference_in_dollars")
        })
        return _obj


