# coding: utf-8

"""
    Ringer Business API - Items Management

    This API provides endpoints for managing individual billable items or features. Items represent the most granular level of service components (e.g., a specific calling feature, a per-minute rate for a call type, a monthly fee for a service). These items can be part of packages or plans.  Currently, this API focuses on allowing updates to items, typically related to their pricing within a specific price deck context. 

    The version of the OpenAPI document: 1.0.0
    Contact: support@ringer.tel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ItemUpdateRequest(BaseModel):
    """
    Specifies the fields that can be updated for an item.
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="New name for the item.")
    item_price: Optional[StrictStr] = Field(default=None, description="New price for the item.")
    tax_category: Optional[StrictInt] = Field(default=None, description="Updated tax category identifier.")
    tax_code: Optional[StrictInt] = Field(default=None, description="Updated tax code.")
    __properties: ClassVar[List[str]] = ["name", "item_price", "tax_category", "tax_code"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ItemUpdateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if tax_category (nullable) is None
        # and model_fields_set contains the field
        if self.tax_category is None and "tax_category" in self.model_fields_set:
            _dict['tax_category'] = None

        # set to None if tax_code (nullable) is None
        # and model_fields_set contains the field
        if self.tax_code is None and "tax_code" in self.model_fields_set:
            _dict['tax_code'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ItemUpdateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "item_price": obj.get("item_price"),
            "tax_category": obj.get("tax_category"),
            "tax_code": obj.get("tax_code")
        })
        return _obj


