# coding: utf-8

"""
    Ringer Business API

    This API provides comprehensive endpoints for the Ringer Business system. It includes functionality for managing customer accounts, addresses, sites,  phone numbers, payments, users, and other business resources.  Operations typically require authentication and appropriate permissions. 

    The version of the OpenAPI document: 1.0.3
    Contact: support@ringer.tel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ringer_business.models.link import Link
from typing import Optional, Set
from typing_extensions import Self

class MenuResponse(BaseModel):
    """
    MenuResponse
    """ # noqa: E501
    name: StrictStr = Field(description="A user-friendly name for the menu.")
    pin: Optional[StrictStr] = Field(default=None, description="Numeric PIN for accessing menu options or management features (if applicable).")
    fail_over_destination_code: StrictStr = Field(description="System code for the destination if no option is selected or an error occurs.")
    id: StrictInt = Field(description="Unique identifier for the menu.")
    site_id: StrictInt = Field(description="Identifier of the site this menu belongs to.")
    options: Optional[Dict[str, Optional[StrictStr]]] = None
    greeting_url: Optional[StrictStr] = Field(default=None, description="URL to the current greeting audio file.")
    links: Optional[List[Link]] = None
    __properties: ClassVar[List[str]] = ["name", "pin", "fail_over_destination_code", "id", "site_id", "options", "greeting_url", "links"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MenuResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item_links in self.links:
                if _item_links:
                    _items.append(_item_links.to_dict())
            _dict['links'] = _items
        # set to None if pin (nullable) is None
        # and model_fields_set contains the field
        if self.pin is None and "pin" in self.model_fields_set:
            _dict['pin'] = None

        # set to None if greeting_url (nullable) is None
        # and model_fields_set contains the field
        if self.greeting_url is None and "greeting_url" in self.model_fields_set:
            _dict['greeting_url'] = None

        # set to None if links (nullable) is None
        # and model_fields_set contains the field
        if self.links is None and "links" in self.model_fields_set:
            _dict['links'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MenuResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "pin": obj.get("pin"),
            "fail_over_destination_code": obj.get("fail_over_destination_code"),
            "id": obj.get("id"),
            "site_id": obj.get("site_id"),
            "options": obj.get("options"),
            "greeting_url": obj.get("greeting_url"),
            "links": [Link.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None
        })
        return _obj


