# coding: utf-8

"""
    Ringer Business API

    This API provides comprehensive endpoints for the Ringer Business system. It includes functionality for managing customer accounts, addresses, sites,  phone numbers, payments, users, and other business resources.  Operations typically require authentication and appropriate permissions. 

    The version of the OpenAPI document: 1.0.3
    Contact: support@ringer.tel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PhoneNumberCreateRequest(BaseModel):
    """
    Data required to assign/create a phone number for a site.
    """ # noqa: E501
    name: StrictStr = Field(description="A user-friendly name for the phone number (e.g., \"Main Line\", \"Sales Dept\").")
    number: StrictStr = Field(description="The actual phone number in E.164 format (e.g., +13035551212).")
    destination_code: StrictStr = Field(description="System code for the primary destination where calls to this number are routed.")
    fail_over_destination_code: Optional[StrictStr] = Field(default=None, description="System code for the failover destination if the primary is unavailable.")
    e911_id: Optional[StrictInt] = Field(default=None, description="Identifier of the E911 record associated with this phone number for emergency calling.")
    user_id: Optional[StrictInt] = Field(default=None, description="Optional. Identifier of a user primarily associated with this phone number.")
    __properties: ClassVar[List[str]] = ["name", "number", "destination_code", "fail_over_destination_code", "e911_id", "user_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PhoneNumberCreateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if fail_over_destination_code (nullable) is None
        # and model_fields_set contains the field
        if self.fail_over_destination_code is None and "fail_over_destination_code" in self.model_fields_set:
            _dict['fail_over_destination_code'] = None

        # set to None if e911_id (nullable) is None
        # and model_fields_set contains the field
        if self.e911_id is None and "e911_id" in self.model_fields_set:
            _dict['e911_id'] = None

        # set to None if user_id (nullable) is None
        # and model_fields_set contains the field
        if self.user_id is None and "user_id" in self.model_fields_set:
            _dict['user_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PhoneNumberCreateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "number": obj.get("number"),
            "destination_code": obj.get("destination_code"),
            "fail_over_destination_code": obj.get("fail_over_destination_code"),
            "e911_id": obj.get("e911_id"),
            "user_id": obj.get("user_id")
        })
        return _obj


