# coding: utf-8

"""
    Ringer Business API

    This API provides comprehensive endpoints for the Ringer Business system. It includes functionality for managing customer accounts, addresses, sites,  phone numbers, payments, users, and other business resources.  Operations typically require authentication and appropriate permissions. 

    The version of the OpenAPI document: 1.0.3
    Contact: support@ringer.tel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ThinClient(BaseModel):
    """
    Represents an available Thin Client (call processing node).
    """ # noqa: E501
    id: StrictInt = Field(description="Unique identifier for the Thin Client.")
    name: StrictStr = Field(description="A descriptive name for the Thin Client (e.g., its location and type).")
    active: StrictBool = Field(description="Indicates if the Thin Client is currently active and available for assignment.")
    category: StrictStr = Field(description="Category of the Thin Client (e.g., public, private).")
    ipv4_address: StrictStr = Field(description="The IPv4 address of the Thin Client.")
    provider: StrictStr = Field(description="The provider or operator of the Thin Client.")
    identification: Optional[StrictStr] = Field(default=None, description="A unique hardware or system identifier for the Thin Client (e.g., MAC address).")
    __properties: ClassVar[List[str]] = ["id", "name", "active", "category", "ipv4_address", "provider", "identification"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ThinClient from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if identification (nullable) is None
        # and model_fields_set contains the field
        if self.identification is None and "identification" in self.model_fields_set:
            _dict['identification'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ThinClient from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "active": obj.get("active"),
            "category": obj.get("category"),
            "ipv4_address": obj.get("ipv4_address"),
            "provider": obj.get("provider"),
            "identification": obj.get("identification")
        })
        return _obj


